# generated by scripts/generate_messages.py

from twnet_parser.pretty_print import PrettyPrint
from twnet_parser.packer import Unpacker
from twnet_parser.chunk_header import ChunkHeader
from twnet_parser.packer import pack_int

class MsgSvSkinChange(PrettyPrint):
    def __init__(
            self,
            client_id: int = 0,
            skin_part_names: int = 0,
            use_custom_colors: int = 0,
            skin_part_colors: int = 0
    ) -> None:
        self.message_name = 'sv_skin_change'
        self.system_message = False
        self.header: ChunkHeader

        self.client_id: int = client_id
        self.skin_part_names: int = skin_part_names
        self.use_custom_colors: int = use_custom_colors
        self.skin_part_colors: int = skin_part_colors

    # first byte of data
    # has to be the first byte of the message payload
    # NOT the chunk header and NOT the message id
    def unpack(self, data: bytes) -> bool:
        unpacker = Unpacker(data)
        self.client_id = unpacker.get_int()
        self.skin_part_names = unpacker.get_int() # TODO: this is an array
        self.use_custom_colors = unpacker.get_int() # TODO: this is an array
        self.skin_part_colors = unpacker.get_int() # TODO: this is an array
        return True

    def pack(self) -> bytes:
        return pack_int(self.client_id) + \
            pack_int(self.skin_part_names) + \
            pack_int(self.use_custom_colors) + \
            pack_int(self.skin_part_colors)